"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const invalidUsage_1 = __importDefault(require("../exceptions/invalidUsage"));
class Collection {
    // create メソッドの this コンテキストのせいで protected にはできない
    /**
     * @deprecated create 経由で生成
     */
    constructor(collections) {
        this.collections = collections;
        if (!Collection._isCreating) {
            throw new invalidUsage_1.default('create経由で生成してください');
        }
        Object.freeze(this.collections);
    }
    [Symbol.iterator]() {
        return this.collections.values();
    }
    find(filter) {
        return this.collections.find(filter);
    }
    filter(filter) {
        return this.collections.filter(filter);
    }
    isEmpty() {
        return !this.collections.length;
    }
    validate(prev) {
        const getPrev = (item) => { var _a; return ((_a = prev === null || prev === void 0 ? void 0 : prev.collections) !== null && _a !== void 0 ? _a : []).find(x => item.equals(x)); };
        const errors = this.collections.reduce((acc, item, index) => (Object.assign(Object.assign({}, acc), Object.fromEntries(Object.entries(item.getErrors(getPrev(item))).map(([key, value]) => [`${key}[${index}]`, value])))), {});
        if (Object.keys(errors).length) {
            return errors;
        }
        return undefined;
    }
    static create(collections) {
        try {
            Collection._isCreating = true;
            return new this(collections);
        }
        finally {
            Collection._isCreating = false;
        }
    }
}
exports.default = Collection;
Collection._isCreating = false;
//# sourceMappingURL=collection.js.map