import type { ValidationErrors } from '../exceptions/validation';
export default abstract class Entity<Args extends any[] = any> {
    private static _isCreating;
    protected constructor();
    protected static _create<Args extends any[], Instance extends Entity<Args>>(this: new (...args: Args) => Instance, ...args: Args): Instance;
    protected static _reconstruct<Args extends any[], Instance extends Entity<Args>>(this: new (...args: Args) => Instance, ...args: Args): Instance;
    protected static _update<Args extends any[], Instance extends Entity<Args>>(this: new (...args: Args) => Instance, target: Entity<Args>, ...args: Args): Instance;
    abstract equals(other: Entity<Args>): boolean;
    getErrors(prev?: Entity<Args>): ValidationErrors;
    private validate;
}
