"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dayjs_1 = __importDefault(require("dayjs"));
const isDate_1 = __importDefault(require("validator/lib/isDate"));
const isISO8601_1 = __importDefault(require("validator/lib/isISO8601"));
const _1 = __importDefault(require("."));
// Inner type = string: consider serialization
class Date extends _1.default {
    fromInput() {
        return (0, dayjs_1.default)(this.input).toISOString();
    }
    toOutput() {
        return (0, dayjs_1.default)(this.inner);
    }
    validate(name) {
        if (typeof this.input === 'string' && !((0, isDate_1.default)(this.input) || (0, isISO8601_1.default)(this.input))) {
            return [{ name, error: '日付の形式が正しくありません' }];
        }
        return undefined;
    }
    compare(value) {
        if (this.value.isSame(value.value)) {
            return 0;
        }
        if (this.value.isBefore(value.value)) {
            return -1;
        }
        return 1;
    }
}
exports.default = Date;
//# sourceMappingURL=date.js.map