export declare type ValidationError = {
    name: string;
    error: string;
};
export default abstract class ValueObject<Input, Output, Inner = Output> {
    private readonly _input;
    private static _isCreating;
    private _setInner;
    private _inner?;
    private _setOutput;
    private _output?;
    /**
     * @deprecated create 経由で生成
     */
    constructor(_input: Input);
    protected abstract get symbol(): symbol;
    protected fromInput(): Inner;
    protected toOutput(): Output;
    protected get input(): Input;
    protected get inner(): Inner;
    get value(): Output;
    equals(value: this): boolean;
    abstract compare(value: this): number;
    abstract validate(name: string, prev?: ValueObject<Input, Output, Inner>): ValidationError[] | undefined;
    static create<Input, Instance extends ValueObject<any, any, any>>(this: new (value: Input) => Instance, value: Input): Instance;
}
