"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = __importDefault(require("."));
class Test extends _1.default {
    get symbol() {
        return Symbol();
    }
    compare() {
        return 0;
    }
    validate() {
        return undefined;
    }
    getInner() {
        return this.inner;
    }
}
class TestArray extends _1.default {
    get symbol() {
        return Symbol();
    }
    compare() {
        return 0;
    }
    validate() {
        return undefined;
    }
}
class TestObject extends _1.default {
    get symbol() {
        return Symbol();
    }
    compare() {
        return 0;
    }
    validate() {
        return undefined;
    }
}
describe('ValueObject', () => {
    it('should cache', () => {
        const test = Test.create(123);
        expect(test.value).toBe(123);
        expect(test.value).toBe(123);
        expect(test.getInner()).toBe(123);
        expect(test.getInner()).toBe(123);
    });
    it('should reconstruct', () => {
        const test = Test.create(123);
        expect(test.value).toBe(123);
        expect(test.value).toBe(123);
    });
    it('should throw error if call constructor directory', () => {
        expect(() => new Test(123)).toThrow();
    });
    it('should throw error if push to array', () => {
        const test = TestArray.create([1, 2, 3]);
        expect(test.value).toEqual([1, 2, 3]);
        expect(test.value).toEqual([1, 2, 3]);
        expect(() => test.value.push(5)).toThrow();
    });
    it('should throw error if update object property', () => {
        const test = TestObject.create({ test: 123 });
        expect(test.value).toEqual({ test: 123 });
        expect(test.value).toEqual({ test: 123 });
        expect(() => {
            test.value.test = 345;
        }).toThrow();
    });
});
//# sourceMappingURL=index.spec.js.map