"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = __importDefault(require("."));
class Text extends _1.default {
    fromInput() {
        if (typeof this.input === 'number') {
            return `${this.input}`;
        }
        if (this.input) {
            return this.input;
        }
        return '';
    }
    getValidationMinLength() {
        return undefined;
    }
    getValidationMaxLength() {
        return undefined;
    }
    validate(name) {
        const text = this.fromInput();
        const results = [];
        if (!text.length) {
            results.push({ name, error: '値を指定してください' });
        }
        else {
            const min = this.getValidationMinLength();
            if (min && text.length < min) {
                results.push({ name, error: `${min}文字より長く入力してください` });
            }
        }
        const max = this.getValidationMaxLength();
        if (max && text.length > max) {
            results.push({ name, error: `${max}文字より短く入力してください` });
        }
        return results;
    }
    compare(value) {
        return this.value.localeCompare(value.value);
    }
}
exports.default = Text;
//# sourceMappingURL=text.js.map